local CdnConfig = require "CdnConfig"

local _M = {}

function _M.filter()
    local cdn = CdnConfig.new()
    cdn:load_cdn(ngx.var.host)
    if cdn.site_configs["content_enable"] ~= true then
        return
    end
    local matcher_list = cdn.site_configs['matcher']

    for i,rule in ipairs( cdn.site_configs["content_rule"] ) do
        local enable = rule['enable']
        local matcher = matcher_list[ rule['matcher'] ] 
        if enable == true and request_tester.test( matcher ) == true then
            local action = rule['action']
            if action == 'gzip' then
                ngx.var.gzip_on = rule['value']
            elseif action == 'brotli' then
                ngx.var.brotli_on = rule['value']
            elseif action == 'pagespeed' then
                ngx.var.ps_on = rule['value']
            else
            
            end
        end
    end
end

return _M