-- -*- coding: utf-8 -*-
-- @Disc    : filter request'uri maybe attack

local _M = {}
local frequency_limit = require "frequency_limit"
local browser_verify = require "browser_verify"
local CdnConfig = require "CdnConfig"
local request_tester = require "request_tester"
local page = require "page"
local util = require "util"

function _M.filter()
    local cdn = CdnConfig.new()
    cdn:load_cdn(ngx.var.host)
    if cdn.site_configs["firewall"] == nil then
        return
    end
    
    ngx.log(ngx.DEBUG, "ngx.re.find( target_var, match_value, 'isjo' )".. ngx.re.find( ngx.var.uri, "/", 'isjo' ))
    for i,rule in ipairs( cdn.site_configs["firewall"] ) do
        local enable = true -- 暂无enable rule['enable']
        -- local matcher = matcher_list[ rule['matcher'] ] 
        if enable == true and request_tester.test( rule['rule'] ) == true then
            -- 
            ngx.var.hit_firewall = rule['id']
            local action = rule['action']
            if action == "ratelimit" and rule['ratelimit'] ~= nil then
                local zone, limits, burst, block_duration
                if (
                tonumber(rule['ratelimit']['limits'])/tonumber(rule['ratelimit']['duration'])) < 1 then
                    local a = math.ceil(60/rule['ratelimit']['duration'])
                    -- 防止频率为小数
                    zone = cdn.site_configs['domain_id'] --.. "_" .. util.real_ip()
                    limits = a*tonumber(rule['ratelimit']['limits']).."r/m"
                    burst = tonumber(rule['ratelimit']['burst'])
                    block_duration = tonumber(rule['ratelimit']['block_duration'])
                else
                    zone = cdn.site_configs['domain_id'] -- .. "_" .. util.real_ip()
                    limits = math.ceil(
                        tonumber(rule['ratelimit']['limits'])/tonumber(rule['ratelimit']['duration'])).."r/s"
                    burst = tonumber(rule['ratelimit']['burst'])
                    block_duration = tonumber(rule['ratelimit']['block_duration'])

                end
                ngx.log(ngx.INFO, "ratelimit:"..
                        zone..','.. limits ..','.. burst ..','.. block_duration)
                -- frequency_limit.init()
                frequency_limit.filter(zone, limits, burst, block_duration)
                return 
                -- 直接返回，不参与下个匹配
            elseif action == 'nowaf' then
                ngx.var.hit_bypass = "yes"
                return 
                -- 直接返回，不参与下个匹配
            elseif action == 'waf' then
                ngx.var.hit_bypass = "no"
            elseif action == "bypass" then
                -- ngx.say('pass')
                ngx.var.reject = ""
                ngx.var.reject_reason = "bypass"
                return
        
            elseif (action == 'js' or action == 'captcha') then
                -- ngx.say('pass')
                -- 检测cookie是否有效以及使用了多少次
                local valid = pcall(function()
                    return (cdn.site_configs['setting']['firewall']['ct'])
                end)
                if not valid then
                    valid = 10
                else
                    valid = tonumber((cdn.site_configs['setting']['firewall']['ct']))
                end
                ngx.var.reject = "yes"
                ngx.var.reject_reason = "challenge"
                browser_verify.filter(action, valid*60)
                ngx.var.reject = "no"
                ngx.var.reject_reason = ""

                return
            elseif action == 'block' then
                    ngx.var.reject = "yes"
                    ngx.var.reject_reason = "block"
                    ngx.header['Content-Type'] = 'text/html'
                    ngx.say(page.get('blkPage'))
                    ngx.exit(ngx.HTTP_OK)
                    return
            else
                return
                    -- ngx.say('o')
                    -- ngx.exit(ngx.HTTP_OK)
            end
            --[[
                if rule['response'] ~= nil then
                    ngx.status = tonumber( rule['code'] )
                    response = response_list[rule['response'\]\]
                    if response ~= nil then
                        ngx.header.content_type = response['content_type']
                        ngx.say( response['body'] )
                        ngx.exit( ngx.HTTP_OK )
                    end
                else
                    ngx.exit( tonumber( rule['code'] ) )
                end
                ]]--
        end
    end
end

return _M
