local cache = require "cache"
local CdnConfig = require "CdnConfig"
local util = require "util"
local ssl = require "ngx.ssl"
--if CdnConfig.site_configs['domain'] == nil then

local cdn = CdnConfig.new()
cdn:load_cdn(ngx.var.host)
ngx.var.eventsid = cdn.configs['id'] ..'-'.. os.time() ..'-'.. util.randomLetter(12) -- ngx.quote_sql_str( )

--end

ngx.var.domain = cdn.site_configs['domain_id']
-- ngx.var.eventsid = CdnConfig.configs['id'] .. os.time() ..'-'.. util.randomLetter(12) -- ngx.quote_sql_str( )
local util = require "util"
local scheme_lock = require "scheme_lock"
-- local redirect = require "redirect"
-- local uri_rewrite = require "uri_rewrite"

-- 开始pagerule
local pagerule = cdn.site_configs['rule']

-- ngx.say(url)
-- local from, to, err= ngx.re.find(url, [[(.*)\.dwt\.life/(.*)/]], 'i')
-- if from ~= nil and to ~= nil then
--     ngx.say('yes')
-- else
--     ngx.say('no')
-- end
-- ngx.exit(0)
ngx.ctx.hsts = false
local action = ""
if pagerule ~= nil then
    for i, rule in ipairs( pagerule ) do
        local matcher = util.string_replace( rule['matcher'], ".", "\\.", 10)
        if ngx.re.match(url, matcher) then
            --[[for a, content in ipairs( rule['content'] ) do
                action = action .. ',' .. a
                if a == "cache" then
                    ngx.req.set_header()
                end
            end ]]--   
            break
        end
    end
end

-- 开始SSL检测
local setting = cdn.site_configs['setting']
if setting ~= nil then

    if setting['ssl'] then
        if setting['ssl']['SSLRewrite'] then
            --ngx.say(setting['ssl']['SSLRewrite'])
            --    ngx.exit(0)
            ngx.ctx.rehttps = true
        end
        if setting['ssl']['forceSSL'] then
            scheme_lock.run('https')
        end
        if setting['ssl']['HSTS'] then
            ngx.ctx.hsts = true
        end
        if ngx.var.scheme == 'https' and setting['ssl']['SSLVersion'] then
            local ver = ssl.get_tls1_version_str()--tonumber(util.string_replace(ssl.get_tls1_version(), '0x030', '', 1))
            if ver == "SSLv3" then
                ver = 0
            elseif ver == "TLSv1" then
                ver = 1
            elseif ver == 'TLSv1.1' then
                ver = 2
            elseif ver == 'TLSv1.2' then
                ver = 3
            else
                ver = 4
            end
            local low = tonumber(util.string_replace(setting['ssl']['SSLVersion'], '0x030', '', 1))
            -- ngx.say(low)
            if ver < low then
                ngx.exit(0)
                return
            end
        end
    end 
end

-- pagerule load完成后进行原规则加载
-- ngx.req.read_body()
-- ngx.ctx.request_body = ngx.req.get_body_data()
--local socket = require("socket.core")
--local breakScoketHandle,debugXpCall = require("LuaDebugOpenrestyJit")("192.168.31.254",7003)
--print("Print test!@!")


if ngx.var.vn_exec_flag and ngx.var.vn_exec_flag ~= '' then -- 内部加载，不做验证
    util.ngx_ctx_load()
    return
end

--At first , make sure every request use latest running config
-- CdnConfig.update_config()

-- scheme_lock.run()
-- redirect.run()
-- uri_rewrite.run()

-- cache.close()