-- -*- coding: utf-8 -*-
-- @Date    : 2016-02-06 22:26
-- @Author  : Alexa (AlexaZhou@163.com)
-- @Link    : 
-- @Disc    : test a request hit a matcher or not

local cookie = require "cookie"
local cidr = require "cidr"
local util = require "util"
local _M = {}

local tester = {}

function _M.test( matcher )
    if matcher == nil then
        return false
    end
    local andc = false
	for name, v in ipairs( matcher ) do
	    -- or 
	    if andc then
	        return true
	    end
	    for k, vv in ipairs( v ) do
	        andc = true
	        -- ngx.say(vv['name'])
	        -- ngx.exit(0)
	        -- and 
	        -- and 要求全部为true 否则跳过，
	        -- 假如and最后所有都为true则全部跳出
    	    -- ngx.say(#v)
    	    -- ngx.say(tester[vv['name']]( vv ))
    	    -- ngx.exit(0)
            if tester[vv['name']] ~= nil then
                if tester[vv['name']]( vv ) ~= true then
                    andc = false -- return false
                    break
    			end
            else
                andc = false
            end
	    end
	end

	return andc
end

--test_var is a basic test method, used by other test method 
function _M.test_var( match_operator, match_value, target_var )
    
   if match_operator == "=" then
        if target_var == match_value then
            return true
        end
    elseif match_operator == "!=" then
        if target_var ~= match_value then
            return true
        end
    elseif match_operator == 'c' then
        -- ngx.log(ngx.DEBUG, "matcher: target_var"..target_var..', match_value: ' .. match_value..','..ngx.re.find( target_var, match_value, 'isjo' ))
        if type(target_var) == 'string' and ngx.re.find( target_var, match_value, 'isjo' ) ~= nil then
            return true
        end
    elseif match_operator == '!c' then
        if type(target_var) ~= 'string' or ngx.re.find( target_var, match_value, 'isjo' ) == nil then
            return true
        end
    elseif match_operator == 'Exist' then
        if target_var ~= nil then
            return true
        end
    elseif match_operator == '!Exist' then
        if target_var == nil then
            return true
        end
    elseif match_operator == '>' then
        if tonumber(target_var) > tonumber(match_value) then
            return true
        end
    elseif match_operator == '>=' then
        if tonumber(target_var) >= tonumber(match_value) then
            return true
        end
    elseif match_operator == '<' then
        if tonumber(target_var) < tonumber(match_value) then
            return true
        end
    elseif match_operator == '<=' then
        if tonumber(target_var) <= tonumber(match_value) then
            return true
        end
    elseif match_operator == 'cl' then
        if type(target_var) ~= 'string' then
            return false
        end
        local arr = util.string_split(match_value, ',')
        for k, v in ipairs(arr) do
            if ngx.re.find( target_var, v, 'isjo' ) ~= nil then
                return true
            end
        end
    elseif match_operator == '!cl' then
        if type(target_var) ~= 'string' then
            return false
        end
        local arr = util.string_split(match_value, ',')
        for k, v in ipairs(arr) do
            if ngx.re.find( target_var, v, 'isjo' ) ~= nil then
                return false
            end
        end
        return true
    end

    return false
end


--test a group of var in table with a condition 
function _M.test_many_var( var_table, condition )
    
    local find = ngx.re.find
    local test_var = _M.test_var

    local name_operator = '=' -- condition['name_operator']
    local arr = util.string_split(condition['value'], '=') -- condition['name_value']
    local name_value = nil
    local value = nil
    if arr ~= nil and #arr == 2 then
        value = arr[1]
        name_value = arr[2]
    elseif arr ~= nil and #arr == 1 then
        name_value = arr[1]
        value = nil
    end
    local operator = condition['condition']

     -- Insert !Exist Check here as it is only applied to operator
    if operator == '!Exist' and name_value ~= nil then
        for k, v in pairs(var_table) do
            if test_var ( name_operator, name_value, k ) == true then
                return false
            end
        end
        return true
    else
        if name_value == nil then
            return false
        end
     -- Normal process
        for k, v in pairs(var_table) do
            if test_var( name_operator, name_value, k ) == true then
                if test_var( operator, value, v ) == true then -- if any one value match the condition, means the matcher has been hited 
                    return true 
                end
            end
        end
    end

    return false
end

function _M.test_uri( condition )
    local uri = ngx.var.uri;
    local ngx_var = ngx.var;
    if ngx_var.args ~= nil then
        uri = ngx_var.scheme.."://"..ngx_var.host..ngx_var.uri.."?"..ngx_var.args
    else
        uri = ngx_var.scheme.."://"..ngx_var.host..ngx_var.uri
    end
    return _M.test_var( condition['condition'], condition['value'], uri )
end

function _M.test_uri_path( condition )
    local uri = ngx.var.uri;
    return _M.test_var( condition['condition'], condition['value'], uri )
end

function _M.ip(value, matcher)
    local retval = cidr.cidr_match(matcher, value)
    if retval == 1 then
        return true
    else
        return false
    end
end
function _M.test_ip( condition )
    local remote_addr = ngx.var.remote_addr
    if condition['condition'] == 'cl' then -- or condition['condition'] == '!cl' then
        local arr = util.string_split(condition['value'], ',')
        for k, v in ipairs(arr) do
            if _M.ip(remote_addr, v) == true then
                return true
            end
        end     
        return false
    end
    if condition['condition'] == '!cl' then -- or condition['condition'] == '!cl' then
        local arr = util.string_split(condition['value'], ',')
        for k, v in ipairs(arr) do
            if _M.ip(remote_addr, v) == true then
                return false
            end
        end        
        return true
    end
    if condition['condition'] == 'c' then -- or condition['condition'] == '!cl' then
        if _M.ip(remote_addr, condition['value']) == true then
            return true
        end
    end
    if condition['condition'] == '!c' then -- or condition['condition'] == '!cl' then
        if _M.ip(remote_addr, condition['value']) == false then
            return true
        end
    end
    if condition['condition'] == '=' then -- or condition['condition'] == '!cl' then
        if remote_addr == condition['value'] then
            return true
        end
    end
    if condition['condition'] == '!=' then -- or condition['condition'] == '!cl' then
        if remote_addr ~= condition['value'] then
            return true
        end
    end
    return false
    -- return _M.test_var( condition['condition'], condition['value'], remote_addr )
end

function _M.test_ua( condition )
    local http_user_agent = ngx.var.http_user_agent;
    return _M.test_var( condition['condition'], condition['value'], http_user_agent )
end

function _M.test_referer( condition )
    local http_referer = ngx.var.http_referer;
    return _M.test_var( condition['condition'], condition['value'], http_referer )
end

function _M.test_method( condition )
    local method_name = ngx.req.get_method()
    return _M.test_var( condition['condition'], condition['value'], method_name )
end

function _M.test_args( condition )
    local find = ngx.re.find
    local test_var = _M.test_var
    local uri_tables = ngx.req.get_uri_args()
    
    if condition['condition'] == 'cl' or condition['condition'] == '!cl' then
        local arr = util.string_split( condition['value'], ',')
        local conditions = condition
        for k, v in ipairs(arr) do
            conditions['value'] = v
            if _M.test_many_var( uri_tables, conditions ) == true then
                return true
            end
        end
        return false
    else
        return _M.test_many_var( uri_tables, condition )
    end
    --[[local arr = nil
    local name_operator = '=' -- condition['name_operator']
    local name_value = condition['name']
    local operator = condition['condition']
    local value = condition['value']
    
    --handle args behind uri
    for k,v in pairs( ngx.req.get_uri_args()) do
        if test_var( name_operator, name_value, k ) == true then
            if type(v) == "table" then
                for arg_idx,arg_value in ipairs(v) do
                    if test_var( operator, value, arg_value ) == true then 
                        return true 
                    end
                end
            else
                if test_var( operator, value, v ) == true then
                    return true 
                end
            end
        end
    end
    ]]--
    ngx.req.read_body()
    --ensure body has not be cached into temp file
    if ngx.req.get_body_file() ~= nil then
        return false
    end
    
    local body_args,err = ngx.req.get_post_args()
    if body_args == nil then
        ngx.say("failed to get post args: ", err)
        return false
    end
    
    if condition['condition'] == 'cl' or condition['condition'] == '!cl' then
        local arr = util.string_split( condition['value'], ',')
        local conditions = condition
        for k, v in ipairs(arr) do
            conditions['value'] = v
            if _M.test_many_var( body_args, conditions ) == true then
                return true
            end
        end
        return false
    else
        return _M.test_many_var( body_args, condition )
    end
    --[[
    --check args in body
    for k,v in pairs( body_args ) do
        if test_var( name_operator, name_value, k ) == true then
            if type(v) == "table" then
                for arg_idx,arg_value in ipairs(v) do
                    if test_var( operator, value, arg_value ) == true then 
                        return true 
                    end
                end
            else
                if test_var( operator, value, v ) == true then
                    return true 
                end
            end
        end
    end

    return false]]--
end

function _M.test_host( condition )
    local hostname = ngx.var.host
    return _M.test_var( condition['condition'], condition['value'], hostname )
end

function _M.test_header( condition )
    local header_table = ngx.req.get_headers()
    if condition['condition'] == 'cl' or condition['condition'] == '!cl' then
        local arr = util.string_split( condition['value'], ',')
        local conditions = condition
        for k, v in ipairs(arr) do
            conditions['value'] = v
            if _M.test_many_var( header_table, conditions ) == true then
                return true
            end
        end
        return false
    else
        return _M.test_many_var( header_table, condition )
    end
end

function _M.test_cookie( condition )
    local cookie_obj, err = cookie:new()
    local cookie_table = cookie_obj:get_all()

    if cookie_table == nil then
        cookie_table = {}
    end--[[
    return _M.test_many_var( cookie_table, condition )
    ]]--
    
    if condition['condition'] == 'cl' or condition['condition'] == '!cl' then
        local arr = util.string_split( condition['value'], ',')
        local conditions = condition
        for k, v in ipairs(arr) do
            conditions['value'] = v
            if _M.test_many_var( cookie_table, conditions ) == true then
                return true
            end
        end
        return false
    else
        return _M.test_many_var( cookie_table, condition )
    end
end

tester["url"] = _M.test_uri
tester["url_path"] = _M.test_uri_path
tester["client_ip"] = _M.test_ip
tester["ua"] = _M.test_ua
tester["http_method"] = _M.test_method
tester["query"] = _M.test_args
tester["refer"] = _M.test_referer
tester["host"] = _M.test_host
tester["header"] = _M.test_header
tester["cookie"] = _M.test_cookie


return _M
