--[[
 重构部分，移植到了filter里面，使得模块从主线分离
]]--
--local summary = require "summary"

if(ngx.re.find(ngx.var.uri, [[/cdn\-cgi/info]], 'i')) then

    local client = require "ip.client"
    local cjson = require "cjson"
    local util = require "util"
    local ssl = require "ngx.ssl"
    local ip = client.get(ngx.var.remote_addr)
    ngx.header['Content-Type'] = 'text'
    ngx.status = ngx.HTTP_OK
    ngx.say("eventid="..ngx.var.eventsid) -- util.string_replace(ngx.var.eventsid, "'", '', 2))
    ngx.say("ip="..ip['ip'])
    ngx.say("country="..ip['country']['iso_code'])
    ngx.say("continent="..ip['continent']['code'])
    ngx.say("ua="..ngx.var.http_user_agent)
    ngx.say("scheme="..(ngx.var.is_https and 'https' or 'http'))
    ngx.say("http_version=http/"..ngx.req.http_version())
    ngx.say("tls="..(ssl.get_tls1_version_str()))
    --ngx.say("continent:"..ip['continent']['names']['en'])
    --ngx.say("country:"..ip['country']['names']['en'])
    --ngx.say("subdivisions:"..ip['subdivisions']['names']['en'])
    -- ngx.say("city:"..ip['city']['names']['en'])
    -- ngx.exit(ngx.OK)   
    -- ngx.var.vn_exec_flag = '1' 
    -- ngx.var.vn_exec_servername = ngx.var.host
    -- ngx.exec("@info")
    return 
end

local filter = require "filter"

-- local frequency_limit = require "frequency_limit"
local CdnConfig = require "CdnConfig"
-- local router = require "router"
--local backend_static = require "backend_static"
local backend_proxy = require "backend_proxy"
local content = require "content"
local util = require "util"
local cache = require "cache"
--cache.init(CdnConfig.configs['redis'], CdnConfig.configs['redis_port'], CdnConfig.configs['redis_pass'], CdnConfig.configs['redis_time'])
local cache_single = require "cache.single"
-- local limit_req = require "resty.limit.req"

if ngx.var.vn_exec_flag and ngx.var.vn_exec_flag ~= '' then
    return
end

ngx.var.limit_rate = "102400K"

--summary.pre_run_matcher()
-- 防火墙匹配
filter.filter()
local ngx_var = ngx.var
local url
if ngx_var.args ~= nil then
    url =  ngx.var.scheme.."://"..ngx_var.host..ngx_var.uri.."?"..ngx_var.args
else
    url =  ngx.var.scheme.."://"..ngx_var.host..ngx_var.uri
end
-- rule 匹配器
if CdnConfig.site_configs ~= nil and CdnConfig.site_configs['rule'] ~= nil then
    for key, rule in ipairs(CdnConfig.site_configs['rule']) do
        ngx.log(ngx.DEBUG, "rule['matcher']:"..rule['matcher'])
        -- local match_url = util.string_replace(util.string_replace(rule['matcher'], [[\*]], "(.*)", 5), [[\.]], "\\.", 10)
        local match_url = util.convertToNgxPattern(rule['matcher'])
        -- util.string_replace(util.string_replace(rule['matcher'], "%*", ".*", 5), "%.", "%%.", 10)
        local from, to, err= ngx.re.find(url, match_url, 'i')
        ngx.log(ngx.DEBUG, "new rule['matcher']:"..match_url)
        if from ~= nil and to ~= nil then
            -- 匹配
            ngx.var.hit_rule = rule['id']
            ngx.log(ngx.DEBUG, "url is:"..url..', matched:'..match_url)
            for s, sv in pairs(rule['content']) do
                for ss, ssv in pairs(sv) do
                    -- ngx.say(s..':'..ss..':'..ssv)
                    -- ngx.exit(0)
                    -- if ngx.var.hit_rule == "" then
                    --     ngx.var.hit_rule = 
                    if CdnConfig.site_configs['setting'][s] == nil then
                        CdnConfig.site_configs['setting'][s] = {}
                    end
                    CdnConfig.site_configs['setting'][s][ss] = ssv
                end
            end
            break
            -- ngx.say(match_url)
        else
            -- ngx.say('no')
        end
        -- ngx.exit(0)
    end
end


-- browser_verify.filter()
-- frequency_limit.filter()
-- router.filter()

if CdnConfig.site_configs['setting'] ~= nil then
    -- 开始功能
    local sets = { 'optimization', 'cache', 'settings', 'firewall'}
    for k, v in pairs(sets) do
        -- 看看是否有： 规则命中 > 整站设置
        if CdnConfig.site_configs['setting'][v] ~= nil then
        -- if k ~= 'firewall' and k ~= 'ssl' and k ~= '' then
        --    local name = "action."..v
        --    if util.isModuleAvailable(name) then --util.file_exists(CdnConfig.home_path() .. '/script/module/action/' .. k .. '.lua') then
        local runtime = require('site_'..v)
        runtime.load(CdnConfig.site_configs['setting'][v], CdnConfig)
        --    end
        -- end
        end
    end
end


local cache_key = ngx.var.host..ngx.var.uri..ngx.var.is_args..(ngx.var.args or '')..(ngx.var.http_range or '')
if ngx.req.get_method() == 'PURGE' then
    local filename = cache_single.cache_filename(CdnConfig.configs['cache_dir'], "1:2", cache_key)
    cache_single.purge(filename)
end
ngx.var.cache_key = cache_key
-- ngx.var.cache_time = cache_time
-- ngx.say(cache_key)
-- ngx.exit(0)
--[[
ngx.header['brotli'] = ngx.var.brotli_on
ngx.header['gzip'] = ngx.var.gzip_on
ngx.header['pagespeed'] = ngx.var.ps_on
]]--
--ngx.say( ngx.var.brotli_on )
--ngx.exit(0)
-- backend_static.filter()
backend_proxy.filter()
content.filter()

-- cache.close()