local CdnConfig = require "CdnConfig"
local util = require "util"
--local cache = require "cache"
    local delay = 3
    function renew_conf()
        --cache.init(CdnConfig.configs["redis"],CdnConfig.configs["redis_port"],CdnConfig.configs["redis_pass"],CdnConfig.configs["redis_time"])
        local domain_list = ngx.shared.domain_list:get('all')
        if domain_list == nil then
            domain_list = ""
        end
        local arr = util.split(domain_list, ',')
        ngx.log(ngx.DEBUG, "domain_list:"..domain_list..','..#arr)
        for _, v in pairs(arr) do 
            ngx.log(ngx.DEBUG, "reload domain: ".. v )
            CdnConfig.tryload(v, true)
        end


        local domain_list = ngx.shared.host_list:get('all')
        if domain_list == nil then
            domain_list = ""
        end
        local arr = util.split(domain_list, ',')
        ngx.log(ngx.DEBUG, "domain_list:"..domain_list..','..#arr)
        for _, v in pairs(arr) do 
            ngx.log(ngx.DEBUG, "reload host: ".. v )
            CdnConfig.load_cdn(v, true)
        end
        local ok, err = ngx.timer.at(delay, renew_conf);
            if not ok then
                ngx.log(ngx.ERROR, "failed to create timer 222.186 : ", err)
                return
            end
    end
    function put_log_into_mysql(premature)      
            local mysql = require "resty.mysql"
            local db, err = mysql:new()
            if not db then
                ngx.log(ngx.DEBUG,"failed to instantiate 222.186 mysql: ", err)
                return
            end

            db:set_timeout(3000)
            local ok, err, errcode, sqlstate = db:connect{
                host = CdnConfig.configs["mysql_host"],
                port = CdnConfig.configs["mysql_port"],
                database = CdnConfig.configs["mysql_db"],
                user = CdnConfig.configs["mysql_user"],
                password = CdnConfig.configs["mysql_pass"],
                charset = "utf8",
            }

            if not ok then
                ngx.timer.at(delay, put_log_into_mysql)
                ngx.log(ngx.ERROR,"failed to connect 222.186 : ", err, ": ", errcode, " ", sqlstate)
                return
            end

            -- get data from shared dict and put them into mysql
            local key = "logs"
            local vals = ""
            local temp_val = ngx.shared.logs:lpop(key)
            while (temp_val ~= nil)
            do
                vals = vals .. ",".. temp_val
                temp_val = ngx.shared.logs:lpop(key)
            end

            if vals ~= "" then
                vals = string.sub(vals, 2,-1)
                local command = ("insert into cdn_logs(event,host,access_ip,ua,method,server_ip,visit_time,request_time,upstream_status,response_time,response_length,request_body_byte,status,url,post_data,`ssl`,domain) values "..vals)
                --ngx.log(ngx.DEBUG,"command is ",command)
                local res, err, errcode, sqlstate = db:query(command)
                if not res then
                    ngx.timer.at(delay, put_log_into_mysql)
                    ngx.log(ngx.ERROR,"insert error: ", err, ": ", errcode, ": ", sqlstate, ".")
                    return
                end
            end

            local ok, err = db:close()
            if not ok then
                ngx.timer.at(delay, put_log_into_mysql)
                ngx.log(ngx.ERROR,"failed to close: ", err)
                return
            end
            -- decycle call timer to run put_log_into_mysql method, just like crontab
            local ok, err = ngx.timer.at(delay, put_log_into_mysql);
            if not ok then
                ngx.log(ngx.ERROR, "failed to create timer 222.186 : ", err)
                return
            end
    end

    local ok, err = ngx.timer.at(delay, renew_conf)
    if not ok then
        ngx.log(ngx.DEBUG, "failed to create timer 222.186 : ", err)
        return
    end
    
--require("ngx.ssl.session.ticket.key_rotation").start_update_timer()
